package api

import (
	"errors"
	"moutai/db/repo"

	"github.com/gin-gonic/gin"
	"go.mongodb.org/mongo-driver/bson"
)

var clickMap = map[string]struct{}{
	repo.CollectionImages: {},
	repo.CollectionVideos: {},
	repo.CollectionRelics: {},
	repo.CollectionVr:     {},
	repo.CollectionAr:     {},
}

func Clicks(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	ClickType := c.Query("type")
	id := c.Query("id")
	if _, ok := clickMap[ClickType]; ok {
		_, err := repo.RepoUpdateSetDocProps(apictx.CreateRepoCtx(), ClickType, id, bson.M{"$inc": bson.M{"clicks": 1}})
		if err != nil {
			return false, err
		}
		return true, nil

	}
	return false, errors.New("参数错误！")

}
