package api

import (
	"fmt"
	"moutai/db/model"
	"moutai/db/repo"
	"time"

	"github.com/gin-gonic/gin"
)

func HomeContent(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	var form model.Home
	err := c.ShouldBindJSON(&form)
	if err != nil {
		return nil, err
	}
	// 先查询是否存在首页类容
	home := model.Home{}
	found, err := repo.RepoSeachDoc(apictx.CreateRepoCtx(), &repo.DocSearchOptions{
		CollectName: repo.CollectionHome,
	}, &home)
	if err != nil {
		return nil, err
	}
	form.UpdateTime = time.Now()
	if found {
		// 更新
		return repo.RepoUpdateSetDoc(apictx.CreateRepoCtx(), repo.CollectionHome, home.Id.Hex(), form)
	} else {
		// 新增
		form.CreateTime = time.Now()
		return repo.RepoAddDoc(apictx.CreateRepoCtx(), repo.CollectionHome, &form)
	}

}

func HomeDetail(c *gin.Context, apictx *ApiSession) (interface{}, error) {
	home := model.Home{}
	_, err := repo.RepoSeachDoc(apictx.CreateRepoCtx(), &repo.DocSearchOptions{
		CollectName: repo.CollectionHome,
	}, &home)
	if err != nil {
		fmt.Println(err)
	}
	return home, nil
}
