package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

type Relics struct {
	Id       primitive.ObjectID `bson:"_id,omitempty" json:"_id,omitempty"`
	Cid      primitive.ObjectID `bson:"cid,omitempty" json:"cid,omitempty"`
	Number   string             `bson:"number,omitempty" json:"number,omitempty"`
	Cover    string             `bson:"cover,omitempty" json:"cover,omitempty"`
	Name     string             `bson:"name,omitempty" json:"name,omitempty"`
	Url      string             `bson:"url,omitempty" json:"url,omitempty"`
	Desc     string             `bson:"desc,omitempty" json:"desc,omitempty"`
	Document *Document          `bson:"document,omitempty" json:"document,omitempty"`

	Clicks int `bson:"clicks,omitempty" json:"clicks,omitempty"`
	Sort   int `bson:"sort,omitempty" json:"sort,omitempty"`

	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime,omitempty"`
	UpdateTime time.Time `bson:"updateTime,omitempty" json:"updateTime,omitempty"`

	// 1 上架 -1下架
	State *int `bson:"state,omitempty" json:"state,omitempty"`
}

type Document struct {
	RepairTime time.Time `bson:"repairTime,omitempty" json:"repairTime,omitempty"`
	Before     []string  `bson:"before,omitempty" json:"before,omitempty"`
	After      []string  `bson:"after,omitempty" json:"after,omitempty"`
	Videos     []string  `bson:"videos,omitempty" json:"videos,omitempty"`
	Audio      []string  `bson:"audio,omitempty" json:"audio,omitempty"`
	IsPublic   *bool     `bson:"isPublic,omitempty" json:"isPublic,omitempty"`
}
