package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

type User struct {
	Id        primitive.ObjectID `bson:"_id,omitempty" json:"_id,omitempty"`
	RoleId    primitive.ObjectID `bson:"roleId,omitempty" json:"roleId,omitempty"`
	LoginName string             `bson:"loginName,omitempty" json:"loginName,omitempty"`
	Password  string             `bson:"password,omitempty" json:"password,omitempty"`
	Avatar    string             `bson:"avatar,omitempty" json:"avatar,omitempty"`
	Name      string             `bson:"name,omitempty" json:"name,omitempty"`
	RoleInfo  *Role              `bson:"roleInfo,omitempty" json:"roleInfo,omitempty"`

	CreateTime time.Time `bson:"createTime,omitempty" json:"createTime,omitempty"`
	UpdateTime time.Time `bson:"updateTime,omitempty" json:"updateTime,omitempty"`

	// 1 正常 -1禁用
	State *int `bson:"state,omitempty" json:"state,omitempty"`
}

func (m *User) GetID() string {
	return m.Id.Hex()
}
