package main

import (
	"fmt"
	"io/ioutil"
	"net/http"
	"net/url"

	"github.com/gin-contrib/cors"
	"github.com/gin-gonic/gin"
)

// https://auth.3dqueen.cloud/login/oauth/authorize?client_id=e537ce727be61ad962d0&redirect_uri=http://localhost:9999/cmf/login/callback&response_type=code&scope=openid&state=STATE
func main() {
	engine := gin.Default()

	// store := cookie.NewStore([]byte("spu3d-server"))
	// engine.Use(sessions.Sessions("dcsession", store))
	// engine.Static("/public", "static")
	config := cors.DefaultConfig()
	// config.AllowOrigins == []string{"http://google.com", "http://facebook.com"}
	config.AllowAllOrigins = true
	config.AllowHeaders = append(config.AllowHeaders, "authorization")
	engine.Use(cors.New(config))

	s := engine.Group("/cmf")
	s.GET("/login/callback", func(ctx *gin.Context) {
		fmt.Println(ctx.Query("code"), ctx.Query("state"))

		code := ctx.Query("code")
		state := ctx.Query("state")

		// 要请求的目标 URL
		baseURL := "http://127.0.0.1:3002/moutai/getToken"

		// 创建请求参数
		params := url.Values{
			"code":  {code},
			"state": {state},
		}

		// 将参数附加到 URL 上
		finalURL := fmt.Sprintf("%s?%s", baseURL, params.Encode())

		// 发起 GET 请求
		resp, err := http.Get(finalURL)
		if err != nil {
			fmt.Println("Error making request:", err)
			return
		}
		defer resp.Body.Close()

		// 读取响应
		body, err := ioutil.ReadAll(resp.Body)
		if err != nil {
			fmt.Println("Error reading response:", err)
			return
		}

		// 打印响应
		fmt.Println(string(body))

		ctx.JSON(200, "success")
	})
	engine.Run(":9999")

}
